All of lore.kernel.org
 help / color / mirror / Atom feed
From: Fam Zheng <famz@redhat.com>
To: qemu-devel@nongnu.org
Cc: Peter Maydell <peter.maydell@linaro.org>
Subject: [Qemu-devel] [PULL 10/17] tests: Add centos VM testing
Date: Wed, 15 Aug 2018 11:12:41 +0800	[thread overview]
Message-ID: <20180815031248.14908-11-famz@redhat.com> (raw)
In-Reply-To: <20180815031248.14908-1-famz@redhat.com>

This one does docker testing in the VM. It is intended to replace the
native docker testing on patchew testers.

Signed-off-by: Fam Zheng <famz@redhat.com>
Message-Id: <20180712012829.20231-5-famz@redhat.com>
Tested-by: Philippe Mathieu-Daudé <f4bug@amsat.org>
Reviewed-by: Philippe Mathieu-Daudé <f4bug@amsat.org>
Signed-off-by: Fam Zheng <famz@redhat.com>
---
 tests/vm/Makefile.include |  3 +-
 tests/vm/centos           | 84 +++++++++++++++++++++++++++++++++++++++
 2 files changed, 86 insertions(+), 1 deletion(-)
 create mode 100755 tests/vm/centos

diff --git a/tests/vm/Makefile.include b/tests/vm/Makefile.include
index 5daa2a3b73..af19b7a4e6 100644
--- a/tests/vm/Makefile.include
+++ b/tests/vm/Makefile.include
@@ -2,7 +2,7 @@
 
 .PHONY: vm-build-all
 
-IMAGES := ubuntu.i386 freebsd netbsd openbsd
+IMAGES := ubuntu.i386 freebsd netbsd openbsd centos
 IMAGE_FILES := $(patsubst %, tests/vm/%.img, $(IMAGES))
 
 .PRECIOUS: $(IMAGE_FILES)
@@ -14,6 +14,7 @@ vm-test:
 	@echo "  vm-build-freebsd                - Build QEMU in FreeBSD VM"
 	@echo "  vm-build-netbsd                 - Build QEMU in NetBSD VM"
 	@echo "  vm-build-openbsd                - Build QEMU in OpenBSD VM"
+	@echo "  vm-build-centos                 - Build QEMU in CentOS VM, with Docker"
 
 vm-build-all: $(addprefix vm-build-, $(IMAGES))
 
diff --git a/tests/vm/centos b/tests/vm/centos
new file mode 100755
index 0000000000..afd560c564
--- /dev/null
+++ b/tests/vm/centos
@@ -0,0 +1,84 @@
+#!/usr/bin/env python
+#
+# CentOS image
+#
+# Copyright 2018 Red Hat Inc.
+#
+# Authors:
+#  Fam Zheng <famz@redhat.com>
+#
+# This code is licensed under the GPL version 2 or later.  See
+# the COPYING file in the top-level directory.
+#
+
+import os
+import sys
+import subprocess
+import basevm
+import time
+
+class CentosVM(basevm.BaseVM):
+    name = "centos"
+    BUILD_SCRIPT = """
+        set -e;
+        cd $(mktemp -d);
+        export SRC_ARCHIVE=/dev/vdb;
+        sudo chmod a+r $SRC_ARCHIVE;
+        tar -xf $SRC_ARCHIVE;
+        make docker-test-block@centos7 V={verbose} J={jobs};
+        make docker-test-quick@centos7 V={verbose} J={jobs};
+        make docker-test-mingw@fedora V={verbose} J={jobs};
+    """
+
+    def _gen_cloud_init_iso(self):
+        cidir = self._tmpdir
+        mdata = open(os.path.join(cidir, "meta-data"), "w")
+        mdata.writelines(["instance-id: centos-vm-0\n",
+                          "local-hostname: centos-guest\n"])
+        mdata.close()
+        udata = open(os.path.join(cidir, "user-data"), "w")
+        udata.writelines(["#cloud-config\n",
+                          "chpasswd:\n",
+                          "  list: |\n",
+                          "    root:%s\n" % self.ROOT_PASS,
+                          "    %s:%s\n" % (self.GUEST_USER, self.GUEST_PASS),
+                          "  expire: False\n",
+                          "users:\n",
+                          "  - name: %s\n" % self.GUEST_USER,
+                          "    sudo: ALL=(ALL) NOPASSWD:ALL\n",
+                          "    ssh-authorized-keys:\n",
+                          "    - %s\n" % basevm.SSH_PUB_KEY,
+                          "  - name: root\n",
+                          "    ssh-authorized-keys:\n",
+                          "    - %s\n" % basevm.SSH_PUB_KEY,
+                          "locale: en_US.UTF-8\n"])
+        udata.close()
+        subprocess.check_call(["genisoimage", "-output", "cloud-init.iso",
+                               "-volid", "cidata", "-joliet", "-rock",
+                               "user-data", "meta-data"],
+                               cwd=cidir,
+                               stdin=self._devnull, stdout=self._stdout,
+                               stderr=self._stdout)
+        return os.path.join(cidir, "cloud-init.iso")
+
+    def build_image(self, img):
+        cimg = self._download_with_cache("https://cloud.centos.org/centos/7/images/CentOS-7-x86_64-GenericCloud-1802.qcow2.xz")
+        img_tmp = img + ".tmp"
+        subprocess.check_call(["cp", "-f", cimg, img_tmp + ".xz"])
+        subprocess.check_call(["xz", "-df", img_tmp + ".xz"])
+        subprocess.check_call(["qemu-img", "resize", img_tmp, "50G"])
+        self.boot(img_tmp, extra_args = ["-cdrom", self._gen_cloud_init_iso()])
+        self.wait_ssh()
+        self.ssh_root_check("touch /etc/cloud/cloud-init.disabled")
+        self.ssh_root_check("yum update -y")
+        self.ssh_root_check("yum install -y docker make git")
+        self.ssh_root_check("systemctl enable docker")
+        self.ssh_root("poweroff")
+        self.wait()
+        if os.path.exists(img):
+            os.remove(img)
+        os.rename(img_tmp, img)
+        return 0
+
+if __name__ == "__main__":
+    sys.exit(basevm.main(CentosVM))
-- 
2.17.1

  parent reply	other threads:[~2018-08-15  3:13 UTC|newest]

Thread overview: 21+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2018-08-15  3:12 [Qemu-devel] [PULL 00/17] Block and testing patches Fam Zheng
2018-08-15  3:12 ` [Qemu-devel] [PULL 01/17] tests/vm: Only use -cpu 'host' if KVM is available Fam Zheng
2018-08-15  3:12 ` [Qemu-devel] [PULL 02/17] tests/vm: Add flex and bison to the vm image Fam Zheng
2018-08-15  3:12 ` [Qemu-devel] [PULL 03/17] nvme: Fix nvme_init error handling Fam Zheng
2018-08-15  3:12 ` [Qemu-devel] [PULL 04/17] nvme: simplify plug/unplug Fam Zheng
2018-08-15  3:12 ` [Qemu-devel] [PULL 05/17] aio-posix: Don't count ctx->notifier as progress when polling Fam Zheng
2018-08-15  3:12 ` [Qemu-devel] [PULL 06/17] aio: Do aio_notify_accept only during blocking aio_poll Fam Zheng
2018-08-15  3:12 ` [Qemu-devel] [PULL 07/17] docker: Install more packages in centos7 Fam Zheng
2018-08-15  3:12 ` [Qemu-devel] [PULL 08/17] tests: Add an option for snapshot (default: off) Fam Zheng
2018-08-15  3:12 ` [Qemu-devel] [PULL 09/17] tests: Allow overriding archive path with SRC_ARCHIVE Fam Zheng
2018-08-15  3:12 ` Fam Zheng [this message]
2018-08-15  3:12 ` [Qemu-devel] [PULL 11/17] tests: vm: Add vm-clean-all Fam Zheng
2018-08-15  3:12 ` [Qemu-devel] [PULL 12/17] tests/vm: Pass the jobs parallelism setting to 'make check' Fam Zheng
2018-08-15  3:12 ` [Qemu-devel] [PULL 13/17] tests/vm: Propagate V=1 down into the make inside the VM Fam Zheng
2018-08-15  3:12 ` [Qemu-devel] [PULL 14/17] tests/vm: Bump guest RAM up from 2G to 4G Fam Zheng
2018-08-15  3:12 ` [Qemu-devel] [PULL 15/17] tests/vm: Use make's --output-sync option Fam Zheng
2018-08-15  3:12 ` [Qemu-devel] [PULL 16/17] tests/vm: Add vm-build-all/vm-clean-all in help text Fam Zheng
2018-08-15  3:12 ` [Qemu-devel] [PULL 17/17] aio-posix: Improve comment around marking node deleted Fam Zheng
2018-08-15 15:31 ` [Qemu-devel] [PULL 00/17] Block and testing patches Peter Maydell
2018-08-15 15:35 ` Peter Maydell
2018-08-16  4:34   ` Fam Zheng

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20180815031248.14908-11-famz@redhat.com \
    --to=famz@redhat.com \
    --cc=peter.maydell@linaro.org \
    --cc=qemu-devel@nongnu.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.